#include <inttypes.h>
#include <stdio.h>

/* GNU Octave:
[b,a]=ellip(6,1,60,0.125) % cauer 1dB ripple, 60dB Sperr
freqz(b,a)
ra=roots(a)
rb=roots(b)
ai=poly([ra(1),ra(2)])
aii=poly([ra(3),ra(4)])
aiii=poly([ra(5),ra(6)])
bi=poly([rb(1),rb(2)])
bii=poly([rb(3),rb(4)])
biii=poly([rb(5),rb(6)])
freqz(bi,ai)
freqz(bii,aii)
freqz(biii,aiii)
*/

static inline int32_t iiri(int32_t x0)
{
  static int32_t m1,m2;
  int32_t m0;
  int32_t y;
/* ai:  1.00000  -1.81977   0.96909 */ 
/* bi:  1.00000  -0.28894   1.00000 */

  m0 = x0 + (m1 * 29815 - m2 * 15878) / 16384;
   y = m0 + m2 - (m1 * 4734)/16384;

  m2=m1;
  m1=m0;

  y/=8;
  return y;
}
/****************************************************************/
static inline int32_t iirii(int32_t x0)
{
  static int32_t m1,m2;
  int32_t m0;
  int32_t y;
/* aii:  1.00000  -1.79414   0.89143 */ 
/* bii:  1.00000  -1.72167   1.00000 */

  m0 = x0 + (m1 * 29395 - m2 * 14605) / 16384;
   y = m0 + m2 - (m1 * 28208)/16384;

  m2=m1;
  m1=m0;

  y/=8;
  return y;
}
/****************************************************************/
static inline int32_t iiriii(int32_t x0)
{
  static int32_t m1,m2;
  int32_t m0;
  int32_t y;
/* ai:  1.00000  -1.81977   0.96909 */ 
/* bi:  1.00000  -0.28894   1.00000 */

  m0 = x0 + (m1 * 29173 - m2 * 13211) / 16384;
   y = m0 + m2 - (m1 * 25792)/16384;

  m2=m1;
  m1=m0;

  y/=8;
  return y;
}
/****************************************************************/
int main()
{
  int i;
  int dirac;
  for (i=0;i<500;i++)
  {
    dirac=(i==1)?8191:0;
    printf("%d\n",iiriii(iirii(iiri(dirac))));
  }
  return 0;
}

